"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NodePoolGrpcServerDefinition = void 0;
const nodepool_service_stub_1 = require("@jfrog-pipelines/nodepool-service-stub");
const grpc_1 = require("@jfrog-pipelines/grpc");
const configuration_1 = require("@jfrog-pipelines/configuration");
const common_stub_1 = require("@jfrog-pipelines/common-stub");
const NodePoolGrpcRoute_1 = require("./modules/nodePool/NodePoolGrpcRoute");
const GrpcHealthCheck_1 = require("./modules/healthchecks/GrpcHealthCheck");
class NodePoolGrpcServerDefinition {
    constructor() {
        this.protoPackage = 'com.jfrog.pipelines.v1.nodepoolservice';
        this.grpcServerBuilder = new grpc_1.NiceGrpcServerBuilder();
    }
    getPort() {
        return configuration_1.ConfigFactory.config.nodePoolServiceGrpcPort;
    }
    getProto() {
        return this.protoPackage;
    }
    getAddress() {
        return configuration_1.ConfigFactory.config.nodePoolServiceGrpcUrl;
    }
    getServerBuilder() {
        this.grpcServerBuilder.addService(common_stub_1.HealthDefinition, new GrpcHealthCheck_1.NodePoolServiceHealthCheck());
        this.grpcServerBuilder.addService(nodepool_service_stub_1.NodePoolRpcDefinition, new NodePoolGrpcRoute_1.NodePoolGrpcRoute());
        return this.grpcServerBuilder;
    }
}
exports.NodePoolGrpcServerDefinition = NodePoolGrpcServerDefinition;
//# sourceMappingURL=NodePoolGrpcServerDefinition.js.map