"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NodePoolGrpcRoute = void 0;
const logger_1 = require("@jfrog-pipelines/logger");
const data_access_layer_1 = require("@jfrog-pipelines/data-access-layer");
const configuration_1 = require("@jfrog-pipelines/configuration");
const nodepool_service_stub_1 = require("@jfrog-pipelines/nodepool-service-stub");
const NodePoolDao_1 = require("./NodePoolDao");
class NodePoolGrpcRoute {
    constructor() {
        this.properties = configuration_1.ConfigFactory.config;
        this.nodePoolDao = new NodePoolDao_1.NodePoolDao();
    }
    async getNodePool(request) {
        const sqlBuilder = new data_access_layer_1.SequelizeQueryBuilder({});
        sqlBuilder
            .whereWithOperator('id', request.nodePoolIds, data_access_layer_1.operatorsKey.$in)
            .whereWithOperator('projectId', request.projectIds, data_access_layer_1.operatorsKey.$in)
            .whereWithOperator('projectIntegrationId', request.projectIntegrationIds, data_access_layer_1.operatorsKey.$in)
            .whereWithOperator('name', request.names, data_access_layer_1.operatorsKey.$in)
            .whereWithOperator('environments', request.environments, data_access_layer_1.operatorsKey.$in)
            .attributes(request.attributes);
        if (this.properties.isSaaS && !this.properties.getCustom('allowCustomNodes')) {
            sqlBuilder.where('isOnDemand', true);
        }
        const nodePools = await this.nodePoolDao.findAll(sqlBuilder.build());
        return nodepool_service_stub_1.GetNodePoolResponse.fromJSON({ nodePools });
    }
}
__decorate([
    (0, logger_1.Log)(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object]),
    __metadata("design:returntype", Promise)
], NodePoolGrpcRoute.prototype, "getNodePool", null);
exports.NodePoolGrpcRoute = NodePoolGrpcRoute;
//# sourceMappingURL=NodePoolGrpcRoute.js.map